{{

      IR_Remote_NewCog.spin
      Tom Doyle
      2 March 2007

      The IR_Remote.spin object receives and decodes keycodes from a Sony TV remote control.
      The procedure to read and decode is run in a separate cog. This eliminates the big problem
      of the mainline program hanging while waiting for a key to be pressed. When a keycode is
      received it is written into main memory (IRcode) by the cog. See IR_Remote.spin for
      more information.

}}
      

CON

  _CLKMODE = XTAL1 + PLL16X        ' 80 Mhz clock
  _XINFREQ = 5_000_000

  IRdetPin  =    5                   ' IR Receiver - Propeller Pin


OBJ

  ir    : "IR_Remote"
  pst   : "Parallax Serial Terminal"
  num   : "simple_numbers"

VAR

  byte IRcode                                             ' keycode from IR Receiver
  
PUB Init | freq, index, cog, lcode

  if pst.start(9600)
    pst.str(string("IR Remote"))

    cog := ir.Start(IRdetPin, @IRcode)  ' Propeller pin connected to the IR receiver, address of variable
    if cog > 0
      repeat

        If IRcode <> ir#NoNewCode
        
          lcode := IRcode
          ir.Start(IRdetPin, @IRcode)  ' set up for next code
                       
          pst.str(string("Binary: "))
          pst.str(num.bin(lcode, 7))
          pst.str(string("  "))
          pst.str(string("Decimal: "))
          pst.str(num.dec(lcode))
          pst.str(string("  ",13))

        waitcnt((clkfreq / 1000) * 30 + cnt) 
  
        